package xyz.tbvns.Objects;

import lombok.Data;
import xyz.tbvns.GDConstant;

import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.atomic.AtomicReference;

@Data
public class Level {
    private String name;
    private String creator;
    private String description;
    private String encodedLevelString;
    private int nameLine;
    private int creatorLine;
    private int descriptionLine;
    private int encodedLevelStringLine;

    private HashMap<Float, Double> percentToSpeed = new HashMap<>();
    private float maxPos;

    public void read() throws IOException {
        List<Object> objects = Object.fromLevel(this);
        if (objects.getFirst().getProperties().containsKey("kA4")) {
            int speed = Integer.parseInt(objects.getFirst().getProperties().get("kA4"));
            switch (speed) {
                case 0:
                    percentToSpeed.put(0f, GDConstant.SLOW_SPEED);
                case 1:
                    percentToSpeed.put(0f, GDConstant.NORMAL_SPEED);
                case 2:
                    percentToSpeed.put(0f, GDConstant.FAST_SPEED);
                case 3:
                    percentToSpeed.put(0f, GDConstant.FASTER_SPEED);
                case 4:
                    percentToSpeed.put(0f, GDConstant.FASTEST_SPEED);
            }
        } else {
            percentToSpeed.put(0f, GDConstant.NORMAL_SPEED);
        }

        for (Object obj : objects) {
            if (obj.getProperties().containsKey("2")) {
                float x = Float.parseFloat(obj.getProperties().get("2"));
                if (maxPos < x) maxPos = x;
            }
        }

        for (Object obj : objects) {
            if (obj.getProperties().containsKey("1")) {
                float x = Float.parseFloat(obj.getProperties().get("2"));
                if (obj.getProperties().get("1").equals(String.valueOf(GDConstant.SLOW_SPEED_OBJECT_ID))) {
                    percentToSpeed.put((x / maxPos) * 100, GDConstant.SLOW_SPEED);
                } else if (obj.getProperties().get("1").equals(String.valueOf(GDConstant.NORMAL_SPEED_OBJECT_ID))) {
                    percentToSpeed.put((x / maxPos) * 100, GDConstant.NORMAL_SPEED);
                } else if (obj.getProperties().get("1").equals(String.valueOf(GDConstant.FAST_SPEED_OBJECT_ID))) {
                    percentToSpeed.put((x / maxPos) * 100, GDConstant.FAST_SPEED);
                } else if (obj.getProperties().get("1").equals(String.valueOf(GDConstant.FASTER_SPEED_OBJECT_ID))) {
                    percentToSpeed.put((x / maxPos) * 100, GDConstant.FASTER_SPEED);
                } else if (obj.getProperties().get("1").equals(String.valueOf(GDConstant.FASTEST_SPEED_OBJECT_ID))) {
                    percentToSpeed.put((x / maxPos) * 100, GDConstant.FASTEST_SPEED);
                }
            }
        }
    }

    public double getSpeedAt(float percent) {
        AtomicReference<Double> value = new AtomicReference<>((double) 8.6f);
        AtomicReference<Float> max = new AtomicReference<>((float) 0);
        percentToSpeed.forEach((k, v) -> {
            if (max.get() <= k && k <= percent) {
                max.set(k);
                value.set(v);
            }
        });
        return value.get();
    }
}
